VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "CSocket_Server"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

Public Event Error(ByVal Index As Long, ByVal Number As Integer, ByVal Description As String)
Public Event NewClient(ByVal Index As Long)
Public Event SendComplete(ByVal Index As Long)
Public Event DataArrival(ByVal Index As Long, Data As String)
Public Event Closed(ByVal Index As Long)

Private WithEvents myWinsocks As WinsockServer_Form
Attribute myWinsocks.VB_VarHelpID = -1

Private Type tLastPacket
    Index As Long
    Data As String
End Type
Private myLastPacket As tLastPacket

Private Sub Class_Initialize()
 NewInstanz "CSocket_Server"
 Set myWinsocks = New WinsockServer_Form
 myWinsocks.SetClass Me
End Sub

Private Sub Class_Terminate()
 UnloadInstanz "CSocket_Server"
End Sub

Public Sub Cancel()
 myWinsocks.Cancel
 Unload myWinsocks
 Set myWinsocks = Nothing
End Sub

Public Function Listen(ByVal Port As Long) As Integer
    Listen = myWinsocks.Listen(Port)
End Function

Public Sub Disconnect(ByVal Index As Long)
 myWinsocks.Disconnect Index
End Sub

Public Function GetPort(ByVal Index As Long) As Long
 GetPort = myWinsocks.GetPort(Index)
End Function

Public Function GetState(ByVal Index As Long) As sockType
 GetState = myWinsocks.GetState(Index)
End Function

Public Sub SendData(ByVal Index As Long, ByVal Data As String)
    myLastPacket.Index = Index
    myLastPacket.Data = Data
    myWinsocks.SendData Index, Data
End Sub

Public Sub ReSendData()
    With myLastPacket
        myWinsocks.SendData .Index, .Data
    End With
End Sub

Public Function GetClientIP(ByVal Index As Long) As String
 GetClientIP = myWinsocks.GetClientIP(Index)
End Function

Public Function GetServerIP(ByVal Index As Long) As String
 GetServerIP = myWinsocks.GetServerIP(Index)
End Function

Private Sub myWinsocks_Closed(ByVal Index As Long)
 RaiseEvent Closed(Index)
End Sub

Private Sub myWinsocks_DataArrival(ByVal Index As Long, Data As String)
 RaiseEvent DataArrival(Index, Data)
End Sub

Private Sub myWinsocks_Error(ByVal Index As Long, ByVal Number As Integer, ByVal Description As String)
 RaiseEvent Error(Index, Number, Description)
End Sub

Private Sub myWinsocks_NewClient(ByVal Index As Long)
 RaiseEvent NewClient(Index)
End Sub

Private Sub myWinsocks_SendComplete(ByVal Index As Long)
 RaiseEvent SendComplete(Index)
End Sub

Public Property Let Protocol(theType As ProtocolConstants)
    myWinsocks.Listener.Protocol = theType
    Dim W As Winsock
    For Each W In myWinsocks.Clients
        W.Protocol = theType
    Next
End Property

Public Property Get Protocol() As ProtocolConstants
    Protocol = myWinsocks.Listener.Protocol
End Property

Public Property Get LastPacketIndex() As Long
    LastPacketIndex = myLastPacket.Index
End Property

Public Property Get LastPacketData() As String
    LastPacketData = myLastPacket.Data
End Property
