Attribute VB_Name = "Debug_Modul"
Option Explicit

Private ProzessInfo_DebugFile_Engine As Boolean
Private ProzessDebugFile_Engine As Boolean
Private ProzessDebugFile_Engine_Data As String

Private Const LogFile As String = "log.txt"

Private CreateLog As Integer
'0 = nein
'1 = nur debug.print
'2 = nur logfile
'3 = beides

Private Type ClassInstanz
 Name As String
 Anzahl As Long
End Type
Private Instanzen() As ClassInstanz

Private ShowDebugForm As Boolean

Public Sub enable_ProzessInfo()
 ProzessInfo_DebugFile_Engine = True
End Sub

Public Sub enable_ProzessDebugFile_Engine()
 ProzessDebugFile_Engine = True
End Sub

Public Sub set_CreateLogState(ByVal NewValue As Integer)
 CreateLog = NewValue
End Sub

Public Sub Log(ByVal Text As String)
 If Not ProgramIsRunning Then Exit Sub
 
 Select Case CreateLog
  Case 2, 3
   On Error GoTo ResumeIt 'bers Netzwerk treten hier manchmal Fehler auf, die beim nchsten Resume dann aber wieder weg sind
   Dim FileNum%
   FileNum% = FreeFile
   Open Verz + LogFile For Append As FileNum%
   Print #FileNum%, Text
   Close FileNum%
 End Select
 Select Case CreateLog
  Case 1, 3
   Debug.Print Text
 End Select
 If ShowDebugForm And Not Unloading Then DebugForm.AddText Text
 Exit Sub
 
ResumeIt:
 Resume
End Sub

Public Sub show_DebugForm()
 If ShowDebugForm = True Then Exit Sub
 ShowDebugForm = True
 Load DebugForm
 DebugForm.Show
End Sub

Public Sub init_Debug()
 IfExistThenDelete Verz + "debugfile.prozesse"
 IfExistThenDelete Verz + "debugfile.prozessinfo.*"
 ReDim Instanzen(0) As ClassInstanz
 ShowDebugForm = False
 CreateLog = 0
 ProzessDebugFile_Engine = False
 ProzessDebugFile_Engine_Data = "|"
 ProzessInfo_DebugFile_Engine = False
End Sub

Public Sub NewInstanz(ByVal theName As String)
 If Not ProgramIsRunning Then Exit Sub
 If Not ShowDebugForm Then Exit Sub
 If Unloading Then Exit Sub
 
 Dim X As Long
 For X = 1 To UBound(Instanzen)
  If Instanzen(X).Name = theName Then
   Instanzen(X).Anzahl = Instanzen(X).Anzahl + 1
   DebugForm.ListView1.ListItems.Item(X).ListSubItems(1).Text = _
       LTrim$(RTrim$(Str$(Instanzen(X).Anzahl)))
   Exit Sub
  End If
 Next
 
 ReDim Preserve Instanzen(UBound(Instanzen) + 1) As ClassInstanz
 With Instanzen(UBound(Instanzen))
  .Name = theName
  .Anzahl = 1
 End With
 DebugForm.ListView1.ListItems.Add UBound(Instanzen), , theName
 DebugForm.ListView1.ListItems.Item(UBound(Instanzen)).ListSubItems.Add 1, , "1"
End Sub

Public Sub UnloadInstanz(ByVal theName As String)
 If Not ProgramIsRunning Then Exit Sub
 If Not ShowDebugForm Then Exit Sub
 If Unloading Then Exit Sub
 
 Dim X As Long
 For X = 1 To UBound(Instanzen)
  If Instanzen(X).Name = theName Then
   Instanzen(X).Anzahl = Instanzen(X).Anzahl - 1
   DebugForm.ListView1.ListItems.Item(X).ListSubItems(1).Text = _
       LTrim$(RTrim$(Str$(Instanzen(X).Anzahl)))
   Exit Sub
  End If
 Next
End Sub

Public Sub StartProzess(ByVal theName As String)
 If ProzessDebugFile_Engine Then
  ProzessDebugFile_Engine_Data = AddValueToData(ProzessDebugFile_Engine_Data, theName)
  SetOption Verz + "debugfile.prozesse", ProzessDebugFile_Engine_Data
  If ProzessInfo_DebugFile_Engine Then
   CreateFile Verz + "debugfile.prozessinfo." + _
              LTrim$(RTrim$(Str$(GetAnzahlData(ProzessDebugFile_Engine_Data))))
   Log_ProzessInfo ">> " + theName + " <<"
   Log_ProzessInfo "Start..."
  End If
 End If
 
 If Not ProgramIsRunning Then Exit Sub
 If Not ShowDebugForm Then Exit Sub
 If Unloading Then Exit Sub
 
 Dim Index As Long
 Index = GetIndexOfProzess(theName)
 DebugForm.ListView2.ListItems.Item(Index).Tag = _
      LTrim$(RTrim$(Str$(timeGetTime()))) + "|" + _
      DebugForm.ListView2.ListItems.Item(Index).Tag
End Sub

Public Sub EndProzess(ByVal theName As String)
 If ProzessDebugFile_Engine Then
  If ProzessInfo_DebugFile_Engine Then
   IfExistThenDelete Verz + "debugfile.prozessinfo." + _
                     LTrim$(RTrim$(Str$(GetAnzahlData(ProzessDebugFile_Engine_Data))))
  End If
  ProzessDebugFile_Engine_Data = RemoveLastData(ProzessDebugFile_Engine_Data)
  SetOption Verz + "debugfile.prozesse", ProzessDebugFile_Engine_Data
 End If
 
 If Not ProgramIsRunning Then Exit Sub
 If Not ShowDebugForm Then Exit Sub
 If Unloading Then Exit Sub

 Dim Index As Long
 Index = GetIndexOfProzess(theName)
 Dim TheTime As Long
 Dim f As Long
 f = InStr(DebugForm.ListView2.ListItems.Item(Index).Tag, "|")
 TheTime = timeGetTime() - _
           Val(Left$(DebugForm.ListView2.ListItems.Item(Index).Tag, f - 1))
 DebugForm.ListView2.ListItems.Item(Index).Tag = _
      Right$(DebugForm.ListView2.ListItems.Item(Index).Tag, _
             Len(DebugForm.ListView2.ListItems.Item(Index).Tag) - f)
 DebugForm.ListView2.ListItems.Item(Index).ListSubItems.Item(3).Text = _
      LTrim$(RTrim$(Str$(Val(DebugForm.ListView2.ListItems.Item(Index).ListSubItems.Item(3).Text) + _
                         1)))
 DebugForm.ListView2.ListItems.Item(Index).ListSubItems.Item(4).Text = _
      LTrim$(RTrim$(Str$(Val(DebugForm.ListView2.ListItems.Item(Index).ListSubItems.Item(4).Text) + _
                         TheTime)))
 DebugForm.ListView2.ListItems.Item(Index).ListSubItems.Item(1).Text = _
      LTrim$(RTrim$(Str$(Round(Val(DebugForm.ListView2.ListItems.Item(Index).ListSubItems.Item(4).Text) / _
                               Val(DebugForm.ListView2.ListItems.Item(Index).ListSubItems.Item(3).Text), 2))))
 If TheTime > Val(DebugForm.ListView2.ListItems.Item(Index).ListSubItems.Item(2).Text) Then
  DebugForm.ListView2.ListItems.Item(Index).ListSubItems.Item(2).Text = _
       LTrim$(RTrim$(Str$(TheTime)))
 End If
End Sub

Private Function GetIndexOfProzess(ByVal theName As String) As Long
 If LTrim$(RTrim$(theName)) = "" Then
  Log "ERROR in GetIndexOfProzess: TheName = """""
 End If
 Dim X As Long
 For X = 1 To DebugForm.ListView2.ListItems.Count
  If DebugForm.ListView2.ListItems.Item(X).Text = theName Then
   GetIndexOfProzess = X
   Exit Function
  End If
 Next
 
 Dim Temp As ListItem
 Set Temp = DebugForm.ListView2.ListItems.Add()
 Temp.Text = theName
 Temp.ListSubItems.Add 1, , "0"
 Temp.ListSubItems.Add 2, , "0"
 Temp.ListSubItems.Add 3, , "0"
 Temp.ListSubItems.Add 4, , "0"
 GetIndexOfProzess = Temp.Index
End Function

Public Sub Log_ProzessInfo(ByVal Text As String)
 If Not ProzessInfo_DebugFile_Engine Then Exit Sub
 If Not ProgramIsRunning Then Exit Sub
 
 On Error GoTo ResumeIt 'bers Netzwerk treten hier manchmal Fehler auf, die beim nchsten Resume dann aber wieder weg sind
 
 Dim FileNum%
 FileNum% = FreeFile
 Dim FileName As String
 FileName = Verz + "debugfile.prozessinfo." + _
            LTrim$(RTrim$(Str$(GetAnzahlData(ProzessDebugFile_Engine_Data))))
                     
 Open FileName For Append As FileNum%
 Print #FileNum%, Text
 Close FileNum%
 Exit Sub
 
ResumeIt:
 Resume
End Sub
