VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "MainInterface"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

Private URLs() As UrlFileList

Private Const FileName As String = "maindata.dat"

Public Event Change()

Public Function AddURL(ByVal theURL As String) As Long
    AddURL = GetURLIndex(theURL)
    If AddURL = 0 Then
        ReDim Preserve URLs(UBound(URLs) + 1) As UrlFileList
        Set URLs(UBound(URLs)) = New UrlFileList
        URLs(UBound(URLs)).SetParent Me
        URLs(UBound(URLs)).URL = theURL
        URLs(UBound(URLs)).CheckFiles
        AddURL = UBound(URLs)
        SaveData
    End If
End Function

Public Function GetURLsCount() As Long
    GetURLsCount = UBound(URLs)
End Function

Public Function GetURL(ByVal Index As Long) As UrlFileList
    Set GetURL = URLs(Index)
End Function

Public Function GetURLIndex(ByVal theURL As String) As Long
    Dim i As Long
    For i = 1 To UBound(URLs)
        If URLs(i).URL = theURL Then
            GetURLIndex = i
            Exit Function
        End If
    Next
    GetURLIndex = 0
End Function

Public Sub RemoveURL(ByVal theURL As String)
    Dim Index As Long
    Index = GetURLIndex(theURL)
    If Index <> 0 Then
        URLs(Index).Cancel
        Set URLs(Index) = Nothing
        Dim i As Long
        For i = Index To UBound(URLs) - 1
            Set URLs(i) = URLs(i + 1)
        Next
        ReDim Preserve URLs(UBound(URLs) - 1) As UrlFileList
    End If
    SaveData
End Sub

Public Sub Refresh()
    Dim i As Long
    For i = 1 To UBound(URLs)
        URLs(i).RefreshList
    Next
    RaiseEvent Change
End Sub

Private Sub Class_Initialize()
    NewInstanz "MainInterface"
    ReDim URLs(0) As UrlFileList
    loadData
End Sub

Private Sub Class_Terminate()
    UnloadInstanz "MainInterface"
End Sub

Public Sub Cancel()
    Clear
End Sub

Public Sub Clear()
    Dim i As Long
    For i = 1 To UBound(URLs)
        URLs(i).Cancel
        Set URLs(i) = Nothing
    Next
    ReDim URLs(0) As UrlFileList
End Sub

Public Sub CheckFiles()
    Dim i As Long
    For i = 1 To UBound(URLs)
        URLs(i).CheckFiles
    Next
End Sub

Public Sub SaveData()
    Dim Data As String
    Data = ""
    Dim Temp As String
    Dim i As Long
    For i = 1 To UBound(URLs)
        Temp = URLs(i).GetDataToSave()
        Data = Data + DecToBinString(Len(Temp), 3) + Temp
    Next
    
    Dim FileNum%
    FileNum% = FreeFile
    IfExistThenDelete Verz + FileName
    Open Verz + FileName For Binary As FileNum%
    Put #FileNum%, 1, Data
    Close FileNum%
End Sub

Private Sub loadData()
    Clear
            
    Dim FileNum%
    Dim i As Long
    Dim Temp As String
    Dim Data As String
    FileNum% = FreeFile
    IfNotExistThenCreate Verz + FileName
    Open Verz + FileName For Binary As FileNum%
    i = 1
    Do While Not i > LOF(FileNum%)
        Temp = "   "
        Get #FileNum%, i, Temp
        i = i + Len(Temp)
        Data = Space$(BinStringToDec(Temp))
        Get #FileNum%, i, Data
        i = i + Len(Data)
        
        ReDim Preserve URLs(UBound(URLs) + 1) As UrlFileList
        Set URLs(UBound(URLs)) = New UrlFileList
        URLs(UBound(URLs)).SetParent Me
        URLs(UBound(URLs)).SetBySavedData Data
    Loop
    Close FileNum%
End Sub

Public Sub RaiseEvent_Change()
    RaiseEvent Change
End Sub
