Attribute VB_Name = "Mathe_Code"
Option Explicit

Public Declare Function timeGetTime Lib "winmm.dll" () As Long

Public Declare Function GetCursorPos Lib "user32" _
        (lpPoint As POINTAPI) As Long
                                
Public Declare Function ClientToScreen Lib "user32" _
                                (ByVal hwnd As Long, lpPoint As POINTAPI) As Long
                                
Public Type POINTAPI
        X As Long
        Y As Long
End Type

Public Type Point
    X As Double
    Y As Double
End Type

Public Type Position
    Stelle As Point
    Width As Double
    Height As Double
End Type

Public Type ALine
    x1 As Double
    x2 As Double
    y1 As Double
    y2 As Double
End Type

Public Enum eNumberType
    entBin = 1
    entDec = 2
    entHex = 3
End Enum

Public Function GetStartPointOfLine(theLine As ALine) As Point
    GetStartPointOfLine = GetPoint(theLine.x1, theLine.y1)
End Function

Public Function GetEndPointOfLine(theLine As ALine) As Point
    GetEndPointOfLine = GetPoint(theLine.x2, theLine.y2)
End Function

Public Function Get_NewLine(x1 As Double, y1 As Double, x2 As Double, y2 As Double) As ALine
    With Get_NewLine
        .x1 = x1
        .x2 = x2
        .y1 = y1
        .y2 = y2
    End With
End Function

Public Function Betrag(Zahl As Double) As Double
    If Zahl < 0 Then
        Betrag = -Zahl
    Else
        Betrag = Zahl
    End If
End Function

Public Function TheBiggest(Zahl1 As Double, Zahl2 As Double) As Double
    If Zahl1 > Zahl2 Then
        TheBiggest = Zahl1
    Else
        TheBiggest = Zahl2
    End If
End Function

Public Function GetProzent(Wert As Double) As String
    GetProzent = LTrim$(RTrim$(Str$(Int(Wert * 1000) / 10))) + "%"
End Function

Public Function Zufall(Zahl1 As Long, Zahl2 As Long) As Long
    Randomize
    Dim Obergrenze As Long
    Dim Untergrenze As Long
    If Zahl1 > Zahl2 Then
        Obergrenze = Zahl1
        Untergrenze = Zahl2
    Else
        Obergrenze = Zahl2
        Untergrenze = Zahl1
    End If
    Zufall = Int((Obergrenze - Untergrenze + 1) * Rnd + Untergrenze)
End Function

Public Function Point2String(thePoint As Point) As String
    Point2String = LTrim$(RTrim$(Str$(thePoint.X))) + "|" + _
                   LTrim$(RTrim$(Str$(thePoint.Y)))
End Function

Public Function String2Point(theString As String) As Point
    Dim F As Long
    F = InStr(theString, "|")
    If F = 0 Then Exit Function
    String2Point.X = Val(Left$(theString, F - 1))
    String2Point.Y = Val(Right$(theString, Len(theString) - F))
End Function

Public Function GetPoint(X As Double, Y As Double) As Point
    GetPoint.X = X
    GetPoint.Y = Y
End Function

Public Function GetPosition(thePoint As Point, TheWidth As Double, TheHeight As Double) As Position
    GetPosition.Stelle = thePoint
    GetPosition.Width = TheWidth
    GetPosition.Height = TheHeight
End Function

Public Function Position2String(thePosition As Position) As String
    Position2String = Point2String(thePosition.Stelle) + "_" + _
                      LTrim$(RTrim$(Str$(thePosition.Width))) + "|" + _
                      LTrim$(RTrim$(Str$(thePosition.Height)))
End Function

Public Function String2Position(theString As String) As Position
    Dim F As Long
    F = InStr(theString, "_")
    If F = 0 Then Exit Function
    String2Position.Stelle = String2Point(Left$(theString, F - 1))
    String2Position.Width = String2Point(Right$(theString, Len(theString) - F)).X
    String2Position.Height = String2Point(Right$(theString, Len(theString) - F)).Y
End Function

Public Function IsZahl(Zahl As String, Optional Komma As String = ".") As Boolean
    Dim X As Long
    For X = 1 To Len(Zahl)
        Select Case Mid$(Zahl, X, 1)
            Case "-", "0", "1", "2", "3", "4", "5", "6", "7", "8", "9", Komma
                'Zeichen OK
            Case Else
                IsZahl = False
                Exit Function
        End Select
    Next
    IsZahl = True
End Function

Public Function ZwischenWert(Zahl1 As Double, Zahl2 As Double) As Double
    If Zahl1 > Zahl2 Then
        ZwischenWert = Zahl2 + (Zahl1 - Zahl2) / 2
    Else
        ZwischenWert = Zahl1 + (Zahl2 - Zahl1) / 2
    End If
End Function

Public Function IsVersionOK(theVersion As String) As Boolean
    Dim myVersion_Main As Integer
    Dim myVersion_Second As Integer
    Dim theVersion_Main As Integer
    Dim theVersion_Second As Integer
    
    Dim F As Long
    F = InStr(Replace(MyVersion, ",", "."), ".")
    If F = 0 Then
        myVersion_Main = Val(MyVersion)
        myVersion_Second = 0
    Else
        myVersion_Main = Val(Left$(MyVersion, F - 1))
        myVersion_Second = Val(Right$(MyVersion, Len(MyVersion) - F))
    End If
    F = InStr(Replace(theVersion, ",", "."), ".")
    If F = 0 Then
        theVersion_Main = Val(theVersion)
        theVersion_Second = 0
    Else
        theVersion_Main = Val(Left$(theVersion, F - 1))
        theVersion_Second = Val(Right$(theVersion, Len(theVersion) - F))
    End If
    
    If myVersion_Main > theVersion_Main Then
        IsVersionOK = True
    ElseIf myVersion_Main = theVersion_Main Then
        If myVersion_Second >= theVersion_Second Then
            IsVersionOK = True
        Else
            IsVersionOK = False
        End If
    Else
        IsVersionOK = False
    End If
End Function
        
Public Function Bin2Dec(Bin As String) As Long
    Dim i As Long, lngLen As Long
        
    On Error GoTo Bin2DecError
        
    lngLen = Len(Bin)
    
    ' Binrstring zerlegen
    For i = lngLen To 1 Step -1 ' Wir gehen von rechts nach links vor (LSB -> MSB)
            Bin2Dec = Bin2Dec + IIf(Mid$(Bin, i, 1) = "1", 2 ^ (lngLen - i), 0)
    Next i
        
Bin2DecExit:
    Exit Function
                
Bin2DecError:
    ' Wird (beispielsweise) bei Bereichsberschreitung des Long-Datentyps gefeuert
    With Err
            .Raise .Number, .Source, .Description, .HelpFile, .HelpContext
    End With
    Resume Bin2DecExit
                
End Function

Public Function Dec2Bin(ByVal Dec As Long, Optional NumDigitsMin As Long = 0) As String
    Dim i As Long
        
    On Error GoTo Dec2BinError
        
    ' Binren String zusammensetzen
    Do
            If (Dec And 2 ^ i) > 0 Then ' Bit ist zu setzen
                    Dec2Bin = "1" & Dec2Bin  ' "1" setzen
                    Dec = Dec - 2 ^ i ' Subtrahieren fr Abbruchbedingung
            Else
                    Dec2Bin = "0" & Dec2Bin ' "0" setzen
            End If
            i = i + 1 ' Nchste Position
    Loop Until Dec = 0 ' Abbruchbedingung prfen
    
    ' Falls minimale Lnge unterschritten, mit "0" auffllen
    Dec2Bin = Format$(Dec2Bin, String(NumDigitsMin, "0"))
        
Dec2BinExit:
    Exit Function
                
Dec2BinError:
    With Err
            .Raise .Number, .Source, .Description, .HelpFile, .HelpContext
    End With
    Resume Dec2BinExit
                
End Function

Public Function ConvToUnSignedValue(intValue As Integer) As Long
    If intValue >= 0 Then
        ConvToUnSignedValue = intValue
    Else
        ConvToUnSignedValue = intValue + 65535
    End If
End Function

Public Function ConvToSignedValue(lngValue As Long) As Integer
    If lngValue <= 32767 Then
        ConvToSignedValue = CInt(lngValue)
    Else
        ConvToSignedValue = CInt(lngValue - 65535)
    End If
End Function

Public Function IsIntersection(Line1Start As Point, Line1End As Point, Line2Start As Point, Line2End As Point) As Boolean
    Dim ExistIntersection As Boolean
    Dim tmpPoint As Point
    GetIntersection Line1Start, Line1End, Line2Start, Line2End, ExistIntersection, tmpPoint
    IsIntersection = ExistIntersection
End Function

Public Sub GetIntersection(Line1Start As Point, Line1End As Point, Line2Start As Point, Line2End As Point, ByRef ExistIntersection As Boolean, ByRef Intersection As Point)
    Dim m1 As Double
    Dim m2 As Double
    Dim n1 As Double
    Dim n2 As Double
    Dim s1 As Boolean
    Dim s2 As Boolean
    Dim X As Double, Y As Double
    
    If Line1Start.X = Line1End.X Then 'senkrecht
        s1 = True
    Else 'normal
        s1 = False
        m1 = (Line1Start.Y - Line1End.Y) _
           / (Line1Start.X - Line1End.X)
        n1 = Line1Start.Y - Line1Start.X * m1
    End If
    
    If Line2Start.X = Line2End.X Then 'senkrecht
        s2 = True
    Else 'normal
        s2 = False
        m2 = (Line2Start.Y - Line2End.Y) _
           / (Line2Start.X - Line2End.X)
        n2 = Line2Start.Y - Line2Start.X * m2
    End If
    
    If s1 Or s2 Then 'Senkrechte dabei
        If s1 And s2 Then 'parallel oder gleiche Gerade
            If Line1Start.X = Line2Start.X Then 'gleiche Gerade
                If IsBetween(Line1Start.Y, Line2Start.Y, Line2End.Y) Then
                    X = Line1Start.X
                    Y = Line1Start.Y
                ElseIf IsBetween(Line1End.Y, Line2Start.Y, Line2End.Y) Then
                    X = Line1End.X
                    Y = Line1End.Y
                Else
                    ExistIntersection = False
                    Exit Sub
                End If
            Else 'nur parallel ohne Berhrung
                ExistIntersection = False
                Exit Sub
            End If
        Else 'nicht parallel
            If s1 Then
                X = Line1Start.X
                Y = m2 * X + n2
            ElseIf s2 Then
                X = Line2Start.X
                Y = m1 * X + n1
            End If
        End If
    Else 'keine Senkrechte dabei
        If m1 = m2 Then 'parallel oder gleiche Gerade
            If n1 = n2 Then 'gleiche Gerade
                If IsBetween(Line1Start.X, Line2Start.X, Line2End.X) Then
                    X = Line1Start.X
                    Y = Line1Start.Y
                ElseIf IsBetween(Line1End.X, Line2Start.X, Line2End.X) Then
                    X = Line1End.X
                    Y = Line1End.Y
                Else
                    ExistIntersection = False
                    Exit Sub
                End If
            Else 'nur parallel ohne Berhrung
                ExistIntersection = False
                Exit Sub
            End If
        Else 'normal
            X = (n2 - n1) / (m1 - m2)
            Y = m1 * X + n1
        End If
    End If
    
    Intersection.X = X
    Intersection.Y = Y
    ExistIntersection = IsOnLines(Intersection, Line1Start, Line1End, Line2Start, Line2End)
End Sub

Public Function IsOnLines(thePoint As Point, Line1Start As Point, Line1End As Point, Line2Start As Point, Line2End As Point) As Boolean
    IsOnLines = ((IsBetween(thePoint.X, Line1Start.X, Line1End.X) _
              And IsBetween(thePoint.Y, Line1Start.Y, Line1End.Y)) _
             And (IsBetween(thePoint.X, Line2Start.X, Line2End.X) _
              And IsBetween(thePoint.Y, Line2Start.Y, Line2End.Y)))
End Function

Public Function IsBetween(Number As Double, ByVal Number1 As Double, ByVal Number2 As Double) As Boolean
    If Number1 > Number2 Then FlipNumbers Number1, Number2 'Number1=start; Number2=end
    IsBetween = ((Number >= Number1) And (Number <= Number2))
End Function

Public Sub FlipNumbers(ByRef Number1 As Double, ByRef Number2 As Double)
    Dim tmpNumber As Double
    tmpNumber = Number2
    Number2 = Number1
    Number1 = tmpNumber
End Sub

Public Function GetDirection(X As Double, Y As Double)
    If X = 0 Then
        If Y = 0 Then
            GetDirection = -2
        ElseIf Y > 0 Then
            GetDirection = 90
        ElseIf Y < 0 Then
            GetDirection = 270
        End If
    Else
        GetDirection = Atn(Y / X) * (180 / Pi) 'die Richtung in Grad
        If X < 0 Then GetDirection = GetDirection + 180
        GetDirection = GetDirection Mod 360                        '
        If GetDirection < 0 Then GetDirection = GetDirection + 360 'Richtung in [0;360]
    End If
End Function

Public Function SimpleD(d As Double) As Double 'Winkel in [0;360]
    SimpleD = d Mod 360
    If Val(SimpleD) < 0 Then SimpleD = SimpleD + 360
End Function

Public Function Get_TextByNumber( _
                    Number As Long, _
                    Optional Separation As String = ".", _
                    Optional SeparationMinCount As Long = 0, _
                    Optional SeparationSystem As Long = 1000, _
                    Optional NumberType As eNumberType = entDec) _
                                  As String
    
    Dim ln As Long
    ln = Len(GetNumber(SeparationSystem - 1, NumberType))
    
    Dim tmpNumber As Long
    Dim tmpText As String
    Dim sCount As Long
    sCount = 0
    tmpText = ""
    tmpNumber = Number
    
    Do While tmpNumber >= SeparationSystem
        tmpText = Right$(String$(ln, "0") + GetNumber(tmpNumber Mod SeparationSystem, NumberType), ln) + tmpText
        tmpNumber = Int(tmpNumber / SeparationSystem)
        tmpText = Separation + tmpText
        sCount = sCount + 1
    Loop
    
    If sCount >= SeparationMinCount Then
        tmpText = GetNumber(CDbl(tmpNumber), NumberType) + tmpText
    Else
        tmpText = Right$(String$(ln, "0") + GetNumber(tmpNumber Mod SeparationSystem, NumberType), ln) + tmpText
        sCount = sCount + 1
        Do While sCount <= SeparationMinCount
            tmpText = IIf((sCount = SeparationMinCount), _
                          "0", _
                          String$(ln, "0")) + _
                      Separation + tmpText
            sCount = sCount + 1
        Loop
    End If
    
    Get_TextByNumber = tmpText
End Function

Public Sub Test_TimeOfBinConverters(Optional LoopCount As Long = 10000)
    Dim X As Long
    Dim Temp As String
    Dim t As Long
    
    t = timeGetTime()
    For X = 1 To LoopCount
        Temp = Dec2Bin(Zufall(0, 255), 8)
    Next
    Log "Dec2Bin:" + Str$(timeGetTime() - t) + " ms"
    
    t = timeGetTime()
    For X = 1 To LoopCount
        Temp = Get_TextByNumber(Zufall(0, 255), "", 7, 2)
    Next
    Log "Get_TextByNumber:" + Str$(timeGetTime() - t) + " ms"
End Sub

Public Function GetNumber(Number As Double, Optional NumberType As eNumberType = entDec) As String
    Select Case NumberType
        Case entBin
            GetNumber = Dec2Bin(Number)
        Case entDec
            GetNumber = LTrim$(RTrim$(Str$(Number)))
        Case entHex
            GetNumber = Hex$(Number)
    End Select
End Function

Public Function GetDecNumber(Number As String, NumberType As eNumberType) As Double
    Select Case NumberType
        Case entBin
            GetDecNumber = Bin2Dec(Number)
        Case entDec
            GetDecNumber = Val(Number)
        Case entHex
            GetDecNumber = Val("&H" + Number)
    End Select
End Function

Public Function GetNumberSystem(NumberType As eNumberType) As Integer
    Select Case NumberType
        Case entBin
            GetNumberSystem = 2
        Case entDec
            GetNumberSystem = 10
        Case entHex
            GetNumberSystem = 16
        Case Else
            Log "ERROR: GetNumberSystem: " + LTrim$(RTrim$(Str$(NumberType))) + " is not deklared"
    End Select
End Function

Public Function GetNumberType(NumberSystem As Integer) As eNumberType
    Select Case NumberSystem
        Case 2
            GetNumberType = entBin
        Case 10
            GetNumberType = entDec
        Case 16
            GetNumberType = entHex
        Case Else
            Log "ERROR: GetNumberType: " + LTrim$(RTrim$(Str$(NumberSystem))) + " is not deklared"
    End Select
End Function

Public Function Floor(Number As Double) As Double
    Floor = Int(Number)
End Function

Public Function Ceiling(Number As Double) As Double
    Ceiling = -Int(-Number)
End Function

Public Function DecToBinString(Number As Long, Optional Length As Long = 0) As String
    If Length <= 0 Then
        If Number = 0 Then
            Length = 1
        Else
            Length = Floor(Math.Log(Number) / Math.Log(256)) + 1
        End If
    End If
    
    Dim ReturnValue As String
    ReturnValue = ""
    
    Dim i As Long
    For i = 0 To Length - 1
        ReturnValue = ReturnValue + Chr$(Floor(Number / 256 ^ i) Mod 256)
    Next
    
    DecToBinString = ReturnValue
End Function

Public Function BinStringToDec(BinString As String) As Long
    Dim ReturnValue As Long
    ReturnValue = 0
    
    Dim i As Long
    For i = 0 To Len(BinString) - 1
        ReturnValue = ReturnValue + Asc(Mid$(BinString, i + 1, 1)) * 256 ^ i
    Next
    
    BinStringToDec = ReturnValue
End Function
