Attribute VB_Name = "Text_Code"
Option Explicit

Public Function ZTrim$(t$)
    '** Kappen von T$ am 0-Byte
    Dim Drin As Long
    Drin = InStr(t$, vbNullChar)
    If Drin Then
        ZTrim$ = Left$(t$, Drin - 1)
    Else
        ZTrim$ = t$
    End If
End Function

Public Function AZLeft(Text As String, Lnge As Long, Optional NeueZeichen As String = " ") As String
    If Lnge > Len(Text) Then
        AZLeft = Text + String$(Lnge - Len(Text), NeueZeichen)
    Else
        AZLeft = Left$(Text, Lnge)
    End If
End Function

Public Function AZLeftGleich(MainText As String, CompareText As String) As Boolean
    AZLeftGleich = (AZLeft(MainText, Len(CompareText)) = CompareText)
End Function

Public Function AZRight(Text As String, Lnge As Long, Optional NeueZeichen As String = " ") As String
    If Lnge > Len(Text) Then
        AZRight = Text + String$(Lnge - Len(Text), NeueZeichen)
    Else
        AZRight = Right$(Text, Lnge)
    End If
End Function

Public Function AZRightGleich(MainText As String, CompareText As String) As Boolean
    AZRightGleich = (AZRight(MainText, Len(CompareText)) = CompareText)
End Function

Public Function Bytes2Text(AnzBytes As Double, Optional StellenHinterKomma As Integer = 2) As String
    If AnzBytes < 1000 Then
        Bytes2Text = LTrim$(RTrim$(Str$(Round(AnzBytes)))) + " B"
    Else
        If AnzBytes / 1024 < 1000 Then
            Bytes2Text = LTrim$(RTrim$(Str$(Round(AnzBytes / 1024, StellenHinterKomma)))) + " KB"
        Else
            If (AnzBytes / 1024) / 1024 < 1000 Then
                Bytes2Text = LTrim$(RTrim$(Str$(Round((AnzBytes / 1024) / 1024, StellenHinterKomma)))) + " MB"
            Else
                Bytes2Text = LTrim$(RTrim$(Str$(Round(((AnzBytes / 1024) / 1024) / 1024, StellenHinterKomma)))) + " GB"
            End If
        End If
    End If
End Function

Public Function Text2Bytes(ByVal Text As String) As Double
    Dim Zahl As Double
    Dim f As Long
    f = InStr(Text, " ")
    If f = 0 Then
        Text2Bytes = Val(Text)
        Exit Function
    End If
    Zahl = Val(Left$(Text, f - 1))
    Text = UCase$(LTrim$(RTrim$(Right$(Text, Len(Text) - f))))
    Select Case Text
        Case "KB"
            Zahl = Zahl * 1024
        Case "MB"
            Zahl = Zahl * 1024 * 1024
        Case "GB"
            Zahl = Zahl * 1024 * 1024 * 1024
    End Select
    Text2Bytes = Zahl
End Function

Public Function Time2Text(ByVal Sekunden As Long) As String
    Dim Stunden As Long
    Dim Minuten As Long
    Minuten = Int(Sekunden / 60)
    Sekunden = Sekunden - Minuten * 60
    Stunden = Int(Minuten / 60)
    Minuten = Minuten - Stunden * 60
    Time2Text = LTrim$(RTrim$(Str$(Stunden))) + ":" + _
                Right$("00" + LTrim$(RTrim$(Str$(Minuten))), 2) + ":" + _
                Right$("00" + LTrim$(RTrim$(Str$(Sekunden))), 2)
End Function

Public Function CountText(Text As String, SearchText As String) As Long
    CountText = (Len(Text) - Len(Replace(Text, SearchText, ""))) / Len(SearchText)
End Function

Public Function GetAnzahlData(ByVal Text As String, Optional Trennung As String = "|") As Long
    If Not AZRightGleich(Text, Trennung) Then
        Text = Text + Trennung
    End If
    If Not AZLeftGleich(Text, Trennung) Then
        Text = Trennung + Text
    End If
    GetAnzahlData = CountText(Text, Trennung) - 1
End Function

Public Function GetOneData(ByVal Text As String, Index As Long, Optional Trennung As String = "|") As String
    If Not AZLeftGleich(Text, Trennung) Then Exit Function
    Text = Right$(Text, Len(Text) - Len(Trennung))
    Dim X As Long
    X = 0
    Dim F1 As Long
    Dim F2 As Long
    F1 = 1 - Len(Trennung)
    F2 = InStr(Text, Trennung)
    Do While F2 <> 0
        X = X + 1
        If Index = X Then
            GetOneData = Mid$(Text, F1 + Len(Trennung), F2 - F1 - Len(Trennung))
            Exit Function
        End If
        F1 = F2
        F2 = InStr(F2 + Len(Trennung), Text, Trennung)
    Loop
End Function

Public Function GetLastData(ByVal Text As String, Optional Trennung As String = "|") As String
    If Not AZRightGleich(Text, Trennung) Then Exit Function
    Text = Left$(Text, Len(Text) - Len(Trennung))
    Dim f As Long
    f = InStrRev(Text, Trennung)
    If f = 0 Then Exit Function
    GetLastData = Right$(Text, Len(Text) - f + 1 - Len(Trennung))
End Function

Public Function GetFullData(Trennung As String, ParamArray Data() As Variant) As String
    Dim Temp As String
    Temp = Trennung
    Dim X As Long
    For X = LBound(Data) To UBound(Data)
        Temp = Temp + Data(X) + Trennung
    Next
    GetFullData = Temp
End Function

Public Function RemoveLastData(Text As String, Optional Trennung As String = "|") As String
    If Text = "" Then Exit Function
    RemoveLastData = Left$(Text, Len(Text) - Len(GetLastData(Text, Trennung)) - Len(Trennung))
End Function

Public Function RemoveFirstData(ByVal Text As String, Optional Trennung As String = "|") As String
    If Not AZRightGleich(Text, Trennung) Then
        Text = Text + Trennung
    End If
    If Not AZLeftGleich(Text, Trennung) Then
        Text = Trennung + Text
    End If
    RemoveFirstData = Right$(Text, Len(Text) - Len(GetOneData(Text, 1, Trennung)) - Len(Trennung))
End Function

Public Function ExistValueInData(ByVal Text As String, theValue As String, Optional Trennung As String = "|") As Boolean
    If Not AZRightGleich(Text, Trennung) Then
        Text = Text + Trennung
    End If
    If Not AZLeftGleich(Text, Trennung) Then
        Text = Trennung + Text
    End If
    ExistValueInData = (InStr(Text, Trennung + theValue + Trennung) <> 0)
End Function

Public Function RemoveValueInData(Text As String, theValue As String, Optional Trennung As String = "|") As String
    RemoveValueInData = Replace(Text, Trennung + theValue + Trennung, Trennung)
End Function

Public Function AddValueToData(ByVal Text As String, theValue As String, Optional Trennung As String = "|") As String
    If Text = "" Then Text = Trennung
    AddValueToData = Text + theValue + Trennung
End Function

Public Function AddDataToData(ByVal Text As String, ByVal AddData As String, Optional Trennung As String = "|", Optional AddDataTrennung As String = "|") As String
    If Not AddDataTrennung = Trennung Then
        AddData = Replace(AddData, AddDataTrennung, Trennung)
    End If
    If Not AZRightGleich(AddData, Trennung) Then
        AddData = AddData + Trennung
    End If
    If Not AZLeftGleich(AddData, Trennung) Then
        AddData = Trennung + AddData
    End If
    If Not AZRightGleich(Text, Trennung) Then
        Text = Text + Trennung
    End If
    If Not AZLeftGleich(Text, Trennung) Then
        Text = Trennung + Text
    End If
    AddData = Right$(AddData, Len(AddData) - Len(Trennung))
    AddDataToData = Text + AddData
End Function

Public Function GetRestOfValueInData(ByVal Text As String, StartValue As String, Optional Trennung As String = "|", Optional UseUCase As Boolean = False) As String
    If Not AZLeftGleich(Text, Trennung) Then Exit Function
    Text = Right$(Text, Len(Text) - Len(Trennung))
    Dim X As Long
    X = 0
    Dim F1 As Long
    Dim F2 As Long
    F1 = 1 - Len(Trennung)
    F2 = InStr(Text, Trennung)
    Dim Temp As String
    Do While F2 <> 0
        X = X + 1
        Temp = Mid$(Text, F1 + Len(Trennung), F2 - F1 - Len(Trennung))
        If UseUCase Then
            If AZLeftGleich(UCase$(Temp), UCase$(StartValue)) Then
                GetRestOfValueInData = Right$(Temp, Len(Temp) - Len(StartValue))
                Exit Function
            End If
        Else
            If AZLeftGleich(Temp, StartValue) Then
                GetRestOfValueInData = Right$(Temp, Len(Temp) - Len(StartValue))
                Exit Function
            End If
        End If
        F1 = F2
        F2 = InStr(F2 + Len(Trennung), Text, Trennung)
    Loop
End Function

Public Function SetRestOfValueInData(ByVal Text As String, StartValue As String, EndValue As String, Optional Trennung As String = "|", Optional UseUCase As Boolean = False) As String
    If Text = "" Then Text = Trennung
    If Not AZLeftGleich(Text, Trennung) Then Exit Function
    Text = Right$(Text, Len(Text) - Len(Trennung))
    Dim X As Long
    X = 0
    Dim F1 As Long
    Dim F2 As Long
    F1 = 1 - Len(Trennung)
    F2 = InStr(Text, Trennung)
    Dim Temp As String
    Do While F2 <> 0
        X = X + 1
        Temp = Mid$(Text, F1 + Len(Trennung), F2 - F1 - Len(Trennung))
        If UseUCase Then
            If AZLeftGleich(UCase$(Temp), UCase$(StartValue)) Then
                SetRestOfValueInData = Left$(Text, F1 + Len(Trennung) - 1) + StartValue + EndValue + Right$(Text, Len(Text) - F2 + 1)
                Exit Function
            End If
        Else
            If AZLeftGleich(Temp, StartValue) Then
                SetRestOfValueInData = Left$(Text, F1 + Len(Trennung) - 1) + StartValue + EndValue + Right$(Text, Len(Text) - F2 + 1)
                Exit Function
            End If
        End If
        F1 = F2
        F2 = InStr(F2 + Len(Trennung), Text, Trennung)
    Loop
    SetRestOfValueInData = Text + StartValue + EndValue + Trennung
End Function

Public Function RandomText(Length As Long, Optional ByVal SourceText As String = "") As String
    RandomText = ""
    Dim X As Long
    If SourceText = "" Then
        For X = 0 To 255
            SourceText = SourceText + Chr$(X)
        Next
    End If
    For X = 1 To Length
        RandomText = RandomText + Mid$(SourceText, Zufall(1, Len(SourceText)), 1)
    Next
End Function

Public Function Str2Bin(Text As String, Optional NumberType As eNumberType = entBin) As String
    Dim ln As Long
    ln = Len(GetNumber(255, NumberType))
    
    Str2Bin = ""
    
    Dim X As Long
    For X = 1 To Len(Text)
        Str2Bin = Str2Bin + Right(String$(ln, "0") + GetNumber(Asc(Mid$(Text, X, 1)), NumberType), ln)
    Next
End Function

Public Function Bin2Str(Text As String, Optional NumberType As eNumberType = entBin) As String
    Dim ln As Long
    ln = Len(GetNumber(255, NumberType))
    
    Bin2Str = ""
    
    Dim X As Long
    For X = Int(Len(Text) / ln) - 1 To 0 Step -1
        Bin2Str = Chr$(GetDecNumber(Mid$(Text, X * ln + 1, ln), NumberType)) + Bin2Str
    Next
    If (Len(Text) Mod ln) <> 0 Then
        Bin2Str = Chr$(GetDecNumber(Left$(Text, Len(Text) Mod ln), NumberType)) + Bin2Str
    End If
End Function

Public Function ShowBinString(Text As String) As String
    Dim Temp As String
    Dim i As Long
    For i = 1 To Len(Text)
        Temp = Temp + LTrim$(RTrim$(Str$(Asc(Mid$(Text, i, 1)))))
        If (Asc(Mid$(Text, i, 1)) >= 32) _
        And (Asc(Mid$(Text, i, 1)) <= 126) Then
            Temp = Temp + "(" + Mid$(Text, i, 1) + ")"
        End If
        Temp = Temp + ";"
    Next
    ShowBinString = Temp
End Function
