VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "UrlFileList"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

Public URL As String
Private ErrorMsg As String

Public Enum FileState
    fsKnown = 0
    fsNew = 1
    fsOld = 2
End Enum

Private Type AFile
    FileName As String
    State As FileState
End Type

Private Type tList
    FileName As String
    Index As Long
End Type

Private Files() As AFile
Private WithEvents myChecker As UrlFileListChecker
Attribute myChecker.VB_VarHelpID = -1

Private myParent As MainInterface

Public Sub SetParent(theParent As MainInterface)
    Set myParent = theParent
End Sub

Public Function IsChecking() As Boolean
    IsChecking = (Not myChecker Is Nothing)
End Function

Public Function IsError() As Boolean
    IsError = (ErrorMsg <> "")
End Function

Public Function GetErrorMsg() As String
    GetErrorMsg = ErrorMsg
End Function

Public Function GetFilesCount() As Long
    GetFilesCount = UBound(Files)
End Function

Public Function IsChanged() As Boolean
    IsChanged = False
    Dim i As Long
    For i = 1 To UBound(Files)
        If Files(i).State <> fsKnown Then
            IsChanged = True
            Exit Function
        End If
    Next
End Function

Public Function GetFileName(ByVal Index As Long) As String
    GetFileName = Files(Index).FileName
End Function

Public Function GetFileState(ByVal Index As Long) As FileState
    GetFileState = Files(Index).State
End Function

Private Function AddFile(ByVal fName As String, ByVal fState As FileState) As Long
    ReDim Preserve Files(UBound(Files) + 1)
    Files(UBound(Files)).FileName = fName
    Files(UBound(Files)).State = fState
    AddFile = UBound(Files)
End Function

Public Sub CheckFiles()
    If Not myChecker Is Nothing Then
        myChecker.Cancel
        Set myChecker = Nothing
    End If
    
    ErrorMsg = ""
    Set myChecker = New UrlFileListChecker
    myChecker.CheckURL URL
    
    myParent.RaiseEvent_Change
End Sub

Private Sub myChecker_Error(ByVal Msg As String)
    ErrorMsg = Msg
    
    myChecker.Cancel
    Set myChecker = Nothing
    
    myParent.SaveData
    myParent.RaiseEvent_Change
End Sub

Private Sub myChecker_Ready()
    'Filelist berprfen...
    Dim i As Long
    ReDim fList(UBound(Files)) As tList
    Dim UBound_fList As Long
    UBound_fList = UBound(Files)
    For i = 1 To UBound(Files)
        fList(i).FileName = Files(i).FileName
        fList(i).Index = i
    Next
    Dim j As Long
    For i = 1 To myChecker.GetFilesCount()
        For j = 1 To UBound_fList
            If myChecker.GetFile(i) = fList(j).FileName Then
                fList(j) = fList(UBound_fList)
                UBound_fList = UBound_fList - 1
                GoTo CheckNextFile
            End If
        Next
        'new file
        AddFile myChecker.GetFile(i), fsNew
CheckNextFile:
    Next
    For i = 1 To UBound_fList
        'old file
        Files(fList(i).Index).State = fsOld
    Next
    
    myChecker.Cancel
    Set myChecker = Nothing
    
    myParent.SaveData
    myParent.RaiseEvent_Change 'possible change
End Sub

Public Sub RefreshList()
    Dim i As Long
    i = 1
    Do While i <= UBound(Files)
        Select Case Files(i).State
            Case fsNew
                Files(i).State = fsKnown
            Case fsOld
                Files(i) = Files(UBound(Files))
                ReDim Preserve Files(UBound(Files) - 1) As AFile
                i = i - 1
        End Select
        i = i + 1
    Loop
    myParent.SaveData
End Sub

Private Sub Class_Initialize()
    NewInstanz "UrlFileList"
    ReDim Files(0) As AFile
End Sub

Private Sub Class_Terminate()
    UnloadInstanz "UrlFileList"
End Sub

Public Sub Cancel()
    Clear False
    If Not myChecker Is Nothing Then myChecker.Cancel
End Sub

Public Sub Clear(Optional SaveIt As Boolean = True)
    ReDim Files(0) As AFile
    If SaveIt Then myParent.SaveData
End Sub

Public Function GetDataToSave() As String
    Dim Data As String
    Data = ""
    
    Data = Data + DecToBinString(Len(URL), 3) + URL
    Data = Data + DecToBinString(Len(ErrorMsg), 3) + ErrorMsg
    Dim i As Long
    For i = 1 To UBound(Files)
        Data = Data + DecToBinString(Len(Files(i).FileName), 3) + Files(i).FileName
        Data = Data + DecToBinString(Files(i).State, 1)
    Next
    
    GetDataToSave = Data
End Function

Public Sub SetBySavedData(Data As String, Optional ByVal ClearMe As Boolean = True)
    If ClearMe Then Clear False
    
    Dim i As Long
    i = 1
    Dim l As Long
    
    l = BinStringToDec(Mid$(Data, i, 3))
    i = i + 3
    URL = Mid$(Data, i, l)
    i = i + l
    l = BinStringToDec(Mid$(Data, i, 3))
    i = i + 3
    ErrorMsg = Mid$(Data, i, l)
    i = i + l
    Dim fName As String
    Dim fState As FileState
    Do While Not i > Len(Data)
        l = BinStringToDec(Mid$(Data, i, 3))
        i = i + 3
        fName = Mid$(Data, i, l)
        i = i + l
        fState = BinStringToDec(Mid$(Data, i, 1))
        i = i + 1
        AddFile fName, fState
    Loop
End Sub
