VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "UrlFileListChecker"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

Public Event Ready()
Public Event Error(ByVal Msg As String)

Private myURL As URL
Private myURLstr As String
Private Files() As String

Private myFtpClient As SimpleFtpClient
Attribute myFtpClient.VB_VarHelpID = -1

Private Sub Class_Initialize()
    NewInstanz "UrlFileListChecker"
    ReDim Files(0) As String
End Sub

Private Sub Class_Terminate()
    UnloadInstanz "UrlFileListChecker"
End Sub

Public Function GetFilesCount() As Long
    GetFilesCount = UBound(Files)
End Function

Public Function GetFile(ByVal Index As Long) As String
    GetFile = Files(Index)
End Function

Public Function GetURL() As String
    GetURL = myURLstr
End Function

Public Sub Clear()
    ReDim Files(0) As String
End Sub

Public Sub CheckURL(ByVal theURL As String)
    myURLstr = theURL
    myURL = ParseURL(myURLstr)
    Clear
    UnloadFtpClient
    Set myFtpClient = New SimpleFtpClient
    If myFtpClient.Connect(myURL.Host, myURL.Port, myURL.User, myURL.Pass) = 0 Then
        RaiseEvent Error("could not connect")
        Exit Sub
    End If
    If myFtpClient.ChangeDir(myURL.Path) = 0 Then
        RaiseEvent Error("could not change dir")
        Exit Sub
    End If
    
    Dim FileName As String
    Dim hFind As Long
    Dim Result As Long
    Result = myFtpClient.GetFirstFile(FileName)
    hFind = Result
    Do While Result <> 0
        ReDim Preserve Files(UBound(Files) + 1) As String
        Files(UBound(Files)) = FileName
        Result = myFtpClient.GetNextFile(hFind, FileName)
    Loop
    
    myFtpClient.Disconnect
    RaiseEvent Ready
End Sub

Public Sub Cancel()
    UnloadFtpClient
End Sub

Private Sub UnloadFtpClient()
    If Not myFtpClient Is Nothing Then
        myFtpClient.Cancel
        Set myFtpClient = Nothing
    End If
End Sub
